﻿using UnityEngine;
using System.Collections;

public class ParticleRay : MonoBehaviour
{
		GameObject lCam, rCam;

		ParticleSystem particles;

		public float speed;
		void Start ()
		{
				lCam = GameObject.Find ("LeftEyeAnchor");
				rCam = GameObject.Find ("RightEyeAnchor");
				particles = GameObject.Find ("rayParticles").GetComponent<ParticleSystem> ();
		}
	
		void Update ()
		{
				RaycastHit hit;
		
				Vector3 midway = Vector3.Lerp (lCam.transform.position, rCam.transform.position, .5f);
		
				if (Physics.Raycast (midway, lCam.transform.forward, out hit)) {
						float step = speed * Time.deltaTime;
						particles.transform.position = Vector3.MoveTowards (particles.transform.position, hit.point, step);
						particles.emissionRate = 40;

				} else {
						particles.emissionRate = 0;
				}
		}
}
