﻿using UnityEngine;
using System.Collections;

public class carBehave : MonoBehaviour
{
		public Light headLight, tailLight;
		public GameObject headBump, tailBump;
		public Light sirenLight;
		public int id = 0;
		public float life;
		public bool police = false;
		Color pRed, pWhite, pBlue;
		public AudioClip[] engineSounds;
		public AudioClip siren;

		void Start ()
		{
				name = "car" + id;

				if (Random.value <= .2f) {
						police = true;
				}

				if (police) {
						name = "policeCar" + id;
						pRed = new Color (255f / 255f, 30f / 255f, 0f);
						pWhite = new Color (255f / 255f, 235f / 255f, 232f / 255f);
						pBlue = new Color (22f / 255f, 250f / 255f, 223f / 255f);
				}
				headLight.spotAngle = 170;
				life = 0;

				GetComponent<AudioSource> ().clip = engineSounds [Random.Range (0, engineSounds.Length)];
				if (police) {
						GetComponent<AudioSource> ().clip = siren;
						sirenLight.gameObject.SetActive (true);
				} else {
						sirenLight.gameObject.SetActive (false);
				}

				GetComponent<AudioSource> ().Play ();
		}
	
		void Update ()
		{
				life += Time.deltaTime;

				float rand = Random.value;

				transform.Translate (0, 0, 3.5f, Space.Self);

				if (police) {
						if (rand <= .34f) {
								headLight.color = pRed;
						} else if (rand > .67f) {
								headLight.color = pBlue;
						} else {
								headLight.color = pWhite;
						}

						if (Random.value > .5f) {
								headLight.color = new Color (0, 0, 0);
						}

						sirenLight.color = headLight.color;
						sirenLight.transform.Rotate (0, 10, 0);

						headBump.GetComponent<Renderer> ().material.SetColor ("_Color", headLight.color);
				}

		}
}
