﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class controlHub : MonoBehaviour
{


		/* i need to make a new avatar system
	 * so the avatar images will start in the controlhub array which will autofill from the resources folder
	 * after they are loaded they will be shuffled.
	 * a new int tracker will be added to keep track of the people you talk to, incrementing by one each time a new avatar spawns
	 * when a window is spawned, the window will pass the texture to the new window, which will then use it.
	 * 
	 * THATS IT
	 * 
	 * maybe the backgrounds will be passed as well.
	 */


		public List <string> scriptList;
		public List <Transform> locs;
		public List<Texture2D> avatarImgs;
		public List<Texture2D> avatarImgsBump;

		public GameObject windowTemplate;

		public List<List<Texture2D>> texMegaList;

		public TextAsset scriptSource;
		public TextAsset userNameSource;
		public string[] scriptWholes;
		public string[] userNames;

		public GameObject[] avatars;

		public int i, avatarTracker;

		public float life, upperLim, lowerLim, sinkSpeed;

		public GameObject player;

		public bool endGame, frontEnd, typingBlock;

		public AudioClip gameMusic, endGameMusic;

		public GameObject frontEndSphere, tutorial;

		public MovieTexture tutorialMov;

		public int windowTracker = 0;

		public float adSpawnRate = 30;

		public bool title;

		public GameObject titleText, frontEndControl, gameWall;

		GameObject newWindow;

		public GameObject anxietyMaster, anxBuffer;

		public int statusCounter = 0;

		//public Texture2D playerAva;

		public GameObject skyDome;

		int[] myIterator;

		bool pause;

		void Awake ()
		{
				AudioListener.volume = 0;
				int p = 0;
				bool looking = true;
		
				while (looking) {
						string name = "avatars/" + p.ToString ();
			
						Texture2D thisTex = Resources.Load (name) as Texture2D;
						if (thisTex != null) {
								avatarImgs.Add (thisTex);

								name = "avatarsNormals/" + p.ToString ();
								thisTex = Resources.Load (name) as Texture2D;
								avatarImgsBump.Add (thisTex);

								p++;
						} else {
								looking = false;
						}
				}

				for (int t = 0; t < avatarImgs.Count; t++) {
						Texture2D temp = avatarImgs [t];
						int randomIndex = Random.Range (t, avatarImgs.Count);
						avatarImgs [t] = avatarImgs [randomIndex];
						avatarImgs [randomIndex] = temp;
				}

				//avatarTracker = 6;
				userNames = userNameSource.text.Split ('/');

		}
	
	
		void Start ()
		{
				windowTemplate = Resources.Load ("Prefabs/windowBase") as GameObject;

				endGame = false;
				//anxietyMaster.SetActive(false);


				//audio.clip = gameMusic;
				// this is where and when the locations are stored for spawning. from here
				for (int x =0; x < 8; x++) {
						//string name = "loc" + x.ToString ();
						//Transform foundLoc = transform.Find (name);
						//locs.Add (foundLoc);
				} //to here

				i = 0;

				scriptWholes = scriptSource.text.Split ('&');
				//THIS THIS THE GIANT TEXTURE LOADER SCRIPT. i will try to comment every line as clearly as possible
				texMegaList = new List<List<Texture2D>> (); // the creation of the master list of lists.

				bool lookingForConversations = true; // still looking for more conversation groups. It is turned to false when "k_0" returns null.
				int k = 0;//this is the first number, the number of the conversation. This increments until "k_0" returns null.
				List<Texture2D> convoGroup; // The mini placeholder list that will be used to fill the megaList. This will happen every time "k_l" returns null.

				while (lookingForConversations) { //this will only go thru once, when it is false, all the images will be loaded.
						bool lookingForLines = true; // this is controlling when its looking for individual lines

						convoGroup = new List<Texture2D> (); // make the mini list, the one that will be added to the mega list.
						int l = 0; // we are starting by looking for k_0.
						while (lookingForLines) { //this is the process of looking for each image.
								//this is the second number, the number of the line within the conversation. it increments until "k_l" returns null.
								string name = k.ToString () + "_" + l.ToString (); // the images are named "0_1, 4_3 and so on.
								Texture2D thisTex = Resources.Load<Texture2D> (name); // get the next texture, will return "null" if it doesnt exist.

								if (l == 0) { //check if we are done with all of them, meaning, k_0 returns false.
										if (thisTex == null) { // does it?
												lookingForConversations = false;// ok we are done, they are all loaded.
												break;
										}
								}
								if (thisTex != null) { //otherwise, add it to the mini group
										convoGroup.Add (thisTex);
										l++; // look for the next line
								} else {
										texMegaList.Add (convoGroup); // oh it isnt there? ok we are done with this group, add the group we have to the mega group and flush it out.
										lookingForLines = false; // we are out of the mini line loop
										k++; //  start the whole thing again with a new k
								}
						}


				} // end of convoTex loading

				//create random interator

				myIterator = new int[texMegaList.Count];

				for (int x = 0; x < myIterator.Length; x++) {
						myIterator [x] = x;
				}

				//shuffle it

				for (int q = 0; q < myIterator.Length; q++) {
						int temp = myIterator [q];
						int randomIndex = Random.Range (q, myIterator.Length);
						myIterator [q] = myIterator [randomIndex];
						myIterator [randomIndex] = temp;
				}

				//shuffle convoTex

				//life setup

				upperLim = 1f;
				lowerLim = -1f;
				sinkSpeed = 0f;

				life = 1f;
				player = GameObject.Find ("player");
				player.transform.position = new Vector3 (0, life, 0);

				frontEnd = true;
				//gameWall.SetActive(false);

				typingBlock = false;

		} // end of start


		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}

		void Update ()
		{
				if (life < -1.23) {
						GameObject[] windows = GameObject.FindGameObjectsWithTag ("window");
						foreach (GameObject win in windows) {
								win.SetActive (false);
						}
						endGame = true;						
						if (!GameObject.Find ("player/fader").GetComponent<faderBehave> ().fading) {
								PlayerPrefs.SetInt ("echoDone", 1);
								GameObject.Find ("player/fader").SendMessage ("loadLevel", 0f);
						}
				}
				//skyDome.GetComponent<skydomeScript2> ().TIME = map (life,0,1,5.5f,7f); // 5.5 6.2

				if (Input.GetKeyDown (KeyCode.KeypadMultiply)) {
						sinkSpeed += sinkSpeed / 20 * 3f;
				}



				if (endGame) {
						if (sinkSpeed >= 0) {
								sinkSpeed -= sinkSpeed / 20;
						}
				}

				if (frontEnd) {
						frontEnd = frontEndControl.GetComponent<frontEndControl> ().frontEnd;
				}
				if (!frontEnd) {   
						//	gameWall.SetActive(true);//regular duties
						if (!pause) {
								//	if (!endGame) {
								life -= sinkSpeed;
								//	}
						}
						//float playerHeight = life;

						player.transform.position = new Vector3 (0, life, 0);
				}

				pause = false;


				
		}//end of update

		public void spawnWindow (int avatarInt, string userName)
		{

				if (i == myIterator.Length) {
						i = 0;
				}
				newWindow = Instantiate (windowTemplate, new Vector3 (0, 0, 0), Quaternion.identity) as GameObject; //spawn window
				newWindow.GetComponent<chatScreen> ().avatarIdentity = avatarInt; //

				newWindow.transform.rotation = locs [avatarInt].rotation;
				newWindow.transform.localScale = locs [avatarInt].localScale;
				//needs to be shuffled and iterated thru linearly
				newWindow.SendMessage ("parseScript", scriptWholes [myIterator [i]]);
				newWindow.SendMessage ("parseImages", texMegaList [myIterator [i]]);
				newWindow.GetComponent<chatScreen> ().nameString = userName;
				
				//avatarIdentity = avatarImg; this is a note, not actual code.
				//transform.rotation = loc.rotation;this is a note, not actual code.
				//transform.localScale = loc.localScale;this is a note, not actual code.
				//uncutScript = unsplitScriptText; IM DOING MANUAL CONTROL UNTILL I GET THE SCRIPT PARSING SHIT DONE. HOPEFULLY THIS WEEKEND BUT I HAVE A DATE ON SATURDAY SO IDK.
				//convoTex = convoTexs; STILL HAVE THIS UNDER TIGHT DRAGDROP CONTROL
				i++;
		}

		void giveAvatarImg (Texture2D tex)
		{
				newWindow.GetComponent<chatScreen> ().avatarTex = tex;

		}
	
		public	void resetAvatar (int avaInt)
		{
				avatars [avaInt].GetComponent<avatarBehave> ().ready = true;
				avatars [avaInt].GetComponent<avatarBehave> ().userName = userNames [avatarTracker];

				avatars [avaInt].GetComponent<AudioSource> ().Play ();
				avatars [avaInt].GetComponent<Renderer> ().material.SetTexture ("_MainTex", avatarImgs [avatarTracker]);
				//this is where we give them a username

				avatarTracker++;
		                                    
		}

		

		void pauseIt ()
		{
				pause = true;
		}

}



/* hey fucker so this is what u need to do now
 * 
 *the makeCenterRay class will send the spawn message to the avatar window if the name returned is "icon".  DONE
 *
 *the avatar window, IF ITS ACTIVE, will send a message to control hub with its integer identity as an argument. DONE
 *
 *upon recieving this message, the control hub will spawn a new window using 
 *
 *1. the avatar texture for picture,
 *2. a new, unused loc ( using a parallel array of booleans) ,
 *3. ONE BIG "/" DELINIATED script to the new window too. 
 *4. packet of images based on the conversation number.
 *
 *The window will recieve these four packets and parse them, and fill its fucking arrays with them and OFF WE GO!!!!!!!!!!!!
 *
 *DO THIS TOMORROW ASSWIPE.
 *
 * 
 */ 