﻿using UnityEngine;
using System.Collections;
using Uniduino;
public class hardReset : MonoBehaviour
{
		public Arduino arduino;

		int pin = 7;

		int last;

		void Start ()
		{
				arduino = Arduino.global;
				if (arduino != null) {
						arduino.Setup (ConfigurePins);
				}
		}

		void ConfigurePins ()
		{
				arduino.pinMode (pin, PinMode.INPUT);
				arduino.reportDigital ((byte)(pin / 8), 1);
		}
	
		void Update ()
		{
				if (arduino != null) {
						int pinVal = arduino.digitalRead (pin);
						if (arduino.digitalRead (pin) == 1 && pinVal != last) {
								Reset ();
						}
						last = pinVal;
				}

				if (Input.GetKeyDown (KeyCode.KeypadPlus)) {
						Reset ();
				}
		}

		void Reset ()
		{
				PlayerPrefs.SetInt ("echoDone", 0);
				PlayerPrefs.SetInt ("streetDone", 0);
		
				Application.LoadLevel (0);
		}
}
