﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class locationBehave : MonoBehaviour {
	public Texture2D [] texSeq;
	int i,y;
	GameObject player;

	bool highlighted;

	void Start () {
		i =0;
		y=0;
		player = GameObject.Find ("player");
	}
	
	void Update () {
		if(highlighted){
			transform.FindChild("locScreen").gameObject.transform.localScale = new Vector3(.20f,.20f,.20f);
		}else{
			transform.FindChild("locScreen").gameObject.transform.localScale = new Vector3(.10f,.10f,.10f);

		}

		transform.FindChild("locScreen").gameObject.GetComponent<Renderer>().material.SetTexture("_MainTex", texSeq[i%texSeq.Length]);

		if(y % 4 == 0){
			i++;
		}
		y++;

		highlighted = false;

		transform.position = new Vector3(transform.position.x, player.transform.position.y,transform.position.z);
	}

	void parseImages(List<Texture2D> inImages){
		//convoTex = inImages;
		texSeq = new Texture2D[inImages.Count];
		
		for(int x = 0; x < inImages.Count; x++){
			texSeq[x] = inImages[x];
		}
		
		GameObject screen = transform.FindChild("locScreen").gameObject;
		screen.GetComponent<Renderer>().material.SetTexture ("_MainTex", texSeq [0]);
	}

	void activate(){
		Destroy(gameObject);
	}

	void highlight(){
		highlighted = true;
	}
}
