﻿using UnityEngine;
using System.Collections;

public class makeCenterRay:MonoBehaviour
{

		public GameObject lCam, rCam, player;


		void Start ()
		{
	
				lCam = GameObject.Find ("LeftEyeAnchor");
				rCam = GameObject.Find ("RightEyeAnchor");
				player = GameObject.Find ("player");
				lCam.GetComponent<Camera> ().farClipPlane = 10000;
				rCam.GetComponent<Camera> ().farClipPlane = 10000;

		}
	
		void Update ()
		{
				lCam.GetComponent<Camera> ().farClipPlane = 10000;
				rCam.GetComponent<Camera> ().farClipPlane = 10000;
				if (transform.position.y <= -1.5f) {
						//Application.LoadLevel("echoDot");
				} else {
						//transform.Translate(0,-.00032f,0);
				}
				RaycastHit hit;

				Vector3 midway = Vector3.Lerp (lCam.transform.position, rCam.transform.position, .5f);

				if (Physics.Raycast (midway, lCam.transform.forward, out hit)) {

						Debug.DrawLine (midway, hit.point);
						//Debug.Log(hit.collider.gameObject.name);

						GameObject smallTar = hit.collider.gameObject;
						//Debug.Log (smallTar.name);

						if (smallTar.name == "screen") {
								if (Input.GetButtonDown ("ENTER")) {
										GameObject target = smallTar.transform.parent.gameObject;

										target.SendMessage ("activate");
										GetComponent<AudioSource> ().Play ();
								} else {
										GameObject target = smallTar.transform.parent.gameObject;
										if (target.GetComponent<chatScreen> () != null) {
												target.GetComponent<chatScreen> ().highlight = true;
										}

								}
						}

						if (smallTar.name == "icon") {
								if (Input.GetButtonDown ("ENTER")) {
										smallTar.SendMessage ("spawnWindow");
								} else {
										smallTar.GetComponent<avatarBehave> ().highlight = true;
								}
						}

						if (smallTar.tag == "person") {
								float distToPlayer = Vector3.Distance (player.transform.position, smallTar.transform.position);
								if (distToPlayer < 20) {
										smallTar.SendMessage ("activate");
								}

						}

						if (smallTar.name == "adScreen") {
								//smallTar.SendMessage("distort");
						}

						if (smallTar.name == "phone") {
								smallTar.SendMessage ("activate");
						}

						if (smallTar.tag == "frontEndLine") {
								//	smallTar.SendMessage ("invertColor", SendMessageOptions.DontRequireReceiver);
						}

						if (smallTar.tag == "musicPlayer") {
								smallTar.SendMessage ("highlight");
								if (Input.GetButtonDown ("ENTER")) {
										smallTar.SendMessage ("activate");
								}
						}


						if (smallTar.tag == "location") {
								GameObject target = smallTar.transform.parent.gameObject;
								target.SendMessage ("highlight");
								if (Input.GetButtonDown ("ENTER")) {
										target.SendMessage ("activate");
								}
						}

						if (smallTar.tag == "fuckinavatars") {
								smallTar.GetComponent<tutorialAvatarBehave> ().highlight = true;

								if (Input.GetButtonDown ("ENTER")) {
										smallTar.SendMessage ("spawnWindow");
								}

						}

						if (smallTar.tag == "choice") {
								Timer timer = smallTar.transform.Find ("Timer").GetComponent<Timer> ();
								
								smallTar.SendMessage ("highlight");

								if (Input.GetButton ("ENTER")) {
										timer.Play ();
								} else {
										timer.Stop ();
								}
						}

						if (smallTar.tag == "musicButton") {
								smallTar.SendMessage ("Highlight");
								if (Input.GetButtonDown ("ENTER")) {
										smallTar.SendMessage ("Activate");
								}
						}
				}
		}
}
