﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class oldUnderworldControl : MonoBehaviour {
	
	public GameObject lCam,rCam,ground,player,particles;
	
	public List <GameObject> people;
	
	bool musicBuffer = true;
	
	int counter = 0;
	
	float t;
	
	bool endGame = false;
	
	void Start () {
		
		bool looking = true;
		int p =0;
		while(looking){
			string targetName  = name+ "/person"+p.ToString();
			GameObject thisPerson = GameObject.Find(targetName);
			
			if(thisPerson != null){
				people.Add(thisPerson);
				thisPerson.SetActive(false);
				p++;
			}else{
				looking = false;
			}
		}
		
		for (int t = 0; t < people.Count; t++) {
			GameObject temp = people[t];
			int randomIndex = Random.Range(t, people.Count);
			people[t] = people[randomIndex];
			people[randomIndex] = temp;
		}
		
		
	}
	
	void Update () {
		t+= Time.deltaTime;
		lCam.GetComponent<Camera>().backgroundColor = new Color(1,1,1);
		rCam.GetComponent<Camera>().backgroundColor = new Color(1,1,1);
		
		if(musicBuffer){
			if(Time.time >= 2){
				//audio.Play();
				musicBuffer = false;
			}
			
		}
		
		//Debug.Log (audio.time);
		
		if(Input.GetKey(KeyCode.End)){
			endGame = true;
			ground.SendMessage("moveDown");
			
			for(int x =0; x < people.Count; x++){
				people[x].SendMessage("distortLite");
				people[x].SendMessage("floatAway");
			}
		}
		
		if(GetComponent<AudioSource>().time > 71){
			particles.GetComponent<ParticleEmitter>().emit = true;
		}
		if(Input.GetKey(KeyCode.End)){
			Debug.Log (GetComponent<AudioSource>().time);
		}
		
		if(GetComponent<AudioSource>().time > 137){
			endGame = true;
			for(int x =0; x < people.Count; x++){
				people[x].SendMessage("distortLite");
				ground.SendMessage("moveDown");
				people[x].SendMessage("floatAway");
				
			}
		}
		
		if(t > 3){
			spawnPerson();
			t=0;
		}
		
		
		if(Input.GetKeyDown("w")){
			spawnPerson();
		}
		
		if(endGame){
			player.SendMessage("moreSpeed");
		}
		
		//		Debug.Log (Time.time);
	}
	
	void spawnPerson(){
		if(counter < people.Count){
			people[counter].SetActive(true);
			counter++;
		}
	}
}
