﻿using UnityEngine;
using System.Collections;

public class sleepLoader : MonoBehaviour
{
		bool highlighted;
		public bool ready = false;

		public Light lightCone;
		Color coneColor;
		float alph = 0;

		int echoDone, streetDone;
		public TextMesh text;
		AudioSource aSource;
		Timer timer;
		void Start ()
		{
				streetDone = PlayerPrefs.GetInt ("streetDone", 0);
				echoDone = PlayerPrefs.GetInt ("echoDone", 0);

				if ((streetDone == 1) && (echoDone == 1)) {
						text.text = "go to sleep";
						ready = true;
				} else {
						text.text = "";
						ready = false;
						GetComponent<Collider> ().enabled = false;
				}
				coneColor = lightCone.color;

				aSource = GetComponent<AudioSource> ();
				timer = transform.Find ("Timer").GetComponent<Timer> ();
		}
	
		void Update ()
		{
				if (highlighted && ready) {

						if (timer.IsDone ()) {
								if (!aSource.isPlaying) {
										GameObject.Find ("player").SendMessage ("goToSleep");
										GameObject.Find ("fader").SendMessage ("loadLevel", 3f);
										aSource.Play ();
										timer.Stop ();
										timer.enabled = false;
								}
						}

						if (alph < 1) {
								alph += .02f;
						}
				} else {
						if (alph > 0) {
								alph -= .02f;
						}
				}
				Color newCol = new Color (Mathf.Lerp (0, coneColor.r, alph), Mathf.Lerp (0, coneColor.g, alph), Mathf.Lerp (0, coneColor.b, alph), Mathf.Lerp (0, coneColor.a, alph));
				lightCone.color = newCol;
				if (ready) {
						transform.position = new Vector3 (transform.position.x, Mathf.Lerp (-3f, 3, alph), transform.position.z);
				}		
				highlighted = false;
		}
	
		void activate ()
		{
				if (ready) {
						GetComponent<AudioSource> ().Play ();


				}
		}
	
		void highlight ()
		{
				highlighted = true;
		}
}
//-4 to 2