﻿using UnityEngine;
using System.Collections;

public class trafficLightBehave : MonoBehaviour
{

		bool l, o;

		public GameObject f1, f2, f3, l1, l2, l3, r1, r2, r3;

		public GameObject lLight, fLight, rLight;

		public GameObject lCone, fCone, rCone;

		Color red, yellow, green;

		float t = 0;

		GameObject player;

		bool active;

		AudioSource[] aSources;

		void Start ()
		{
				aSources = GetComponents<AudioSource> ();

				red = new Color (50f / 255f, 25f / 255f, 22f / 255f);
				yellow = new Color (50f / 255f, 30f / 255f, 22f / 255f);
				green = new Color (22f / 255f, 50f / 255f, 40f / 255f);

				f1.GetComponent<Renderer> ().material.SetColor ("_Color", red);
				l1.GetComponent<Renderer> ().material.SetColor ("_Color", red);
				r1.GetComponent<Renderer> ().material.SetColor ("_Color", red);
				f2.GetComponent<Renderer> ().material.SetColor ("_Color", yellow);
				l2.GetComponent<Renderer> ().material.SetColor ("_Color", yellow);
				r2.GetComponent<Renderer> ().material.SetColor ("_Color", yellow);
				f3.GetComponent<Renderer> ().material.SetColor ("_Color", green);
				l3.GetComponent<Renderer> ().material.SetColor ("_Color", green);
				r3.GetComponent<Renderer> ().material.SetColor ("_Color", green);

				l = true;
				o = true;

				player = GameObject.Find ("player");

				GetComponent<Animation> () ["trafficLightRotate"].time = Random.Range (0, GetComponent<Animation> () ["trafficLightRotate"].length);

				t = Random.Range (0, 36);

				fLight.SetActive (false);
				lLight.SetActive (false);
				rLight.SetActive (false);
				f1.SetActive (false);
				l1.SetActive (false);
				r1.SetActive (false);
				f2.SetActive (false);
				l2.SetActive (false);
				r2.SetActive (false);
				f3.SetActive (false);
				l3.SetActive (false);
				r3.SetActive (false);
				active = false;
		}
	
		void Update ()
		{
				t += Time.deltaTime;
				float distToPlayer = Vector3.Distance (player.transform.position, transform.position);

				if (distToPlayer < 100) {
						if (!active) {
								GetComponent<AudioSource> ().Play ();
								active = true;
						}


						fLight.SetActive (true);
						lLight.SetActive (true);
						rLight.SetActive (true);

						f1.SetActive (true);
						l1.SetActive (true);
						r1.SetActive (true);
						f2.SetActive (true);
						l2.SetActive (true);
						r2.SetActive (true);
						f3.SetActive (true);
						l3.SetActive (true);
						r3.SetActive (true);

						if ((t > 0) && (t <= 15)) { //rgr
								l = true;
								l1.GetComponent<Renderer> ().material.color = red;
								//lLight.transform.position = new Vector3(lLight.transform.position.x, l1.transform.position.y,lLight.transform.position.z);
								lLight.transform.position = l1.transform.position;
								lLight.GetComponent<Light> ().color = red;
								l2.GetComponent<Renderer> ().material.color = yellow * .04f;
								l3.GetComponent<Renderer> ().material.color = green * .04f;

								f1.GetComponent<Renderer> ().material.color = red * .04f;
								f2.GetComponent<Renderer> ().material.color = yellow * .04f;
								f3.GetComponent<Renderer> ().material.color = green;
								//fLight.transform.position = new Vector3(fLight.transform.position.x, f3.transform.position.y,fLight.transform.position.z);
								fLight.transform.position = f3.transform.position;
								fLight.GetComponent<Light> ().color = green;

								r1.GetComponent<Renderer> ().material.color = red;
								//rLight.transform.position = new Vector3(rLight.transform.position.x, r1.transform.position.y,rLight.transform.position.z);
								rLight.transform.position = r1.transform.position;
								rLight.GetComponent<Light> ().color = red;
								r2.GetComponent<Renderer> ().material.color = yellow * .04f;
								r3.GetComponent<Renderer> ().material.color = green * .04f;

						} else if ((t > 15) && (t <= 18)) { // ryr
								l = false;
								l1.GetComponent<Renderer> ().material.color = red;
								//lLight.transform.position = new Vector3(lLight.transform.position.x, l1.transform.position.y,lLight.transform.position.z);
								lLight.transform.position = l1.transform.position;
								lLight.GetComponent<Light> ().color = red;
								l2.GetComponent<Renderer> ().material.color = yellow * .04f;
								l3.GetComponent<Renderer> ().material.color = green * .04f;
			
								f1.GetComponent<Renderer> ().material.color = red * .04f;
								f2.GetComponent<Renderer> ().material.color = yellow;
								//fLight.transform.position = new Vector3(fLight.transform.position.x, f2.transform.position.y,fLight.transform.position.z);
								fLight.transform.position = f2.transform.position;
								fLight.GetComponent<Light> ().color = yellow;
								f3.GetComponent<Renderer> ().material.color = green * .04f;
			
								r1.GetComponent<Renderer> ().material.color = red;
								//rLight.transform.position = new Vector3(rLight.transform.position.x, r1.transform.position.y,rLight.transform.position.z);
								rLight.transform.position = r1.transform.position;
								rLight.GetComponent<Light> ().color = red;
								r2.GetComponent<Renderer> ().material.color = yellow * .04f;
								r3.GetComponent<Renderer> ().material.color = green * .04f;

						} else if ((t > 18) && (t <= 33)) { //grg
								l = true;
								l1.GetComponent<Renderer> ().material.color = red * .04f;
								l2.GetComponent<Renderer> ().material.color = yellow * .04f;
								l3.GetComponent<Renderer> ().material.color = green;
								//lLight.transform.position = new Vector3(lLight.transform.position.x, l3.transform.position.y,lLight.transform.position.z);
								lLight.transform.position = l3.transform.position;
								lLight.GetComponent<Light> ().color = green;

								f1.GetComponent<Renderer> ().material.color = red;
								//fLight.transform.position = new Vector3(fLight.transform.position.x, f1.transform.position.y,fLight.transform.position.z);
								fLight.transform.position = f1.transform.position;
								fLight.GetComponent<Light> ().color = red;
								f2.GetComponent<Renderer> ().material.color = yellow * .04f;
								f3.GetComponent<Renderer> ().material.color = green * .04f;
			
								r1.GetComponent<Renderer> ().material.color = red * .04f;
								r2.GetComponent<Renderer> ().material.color = yellow * .04f;
								r3.GetComponent<Renderer> ().material.color = green;
								//rLight.transform.position = new Vector3(rLight.transform.position.x, r3.transform.position.y,rLight.transform.position.z);
								rLight.transform.position = r3.transform.position;
								rLight.GetComponent<Light> ().color = green;

						} else if ((t > 33) && (t <= 36)) { //yry
								l = false;
								l1.GetComponent<Renderer> ().material.color = red * .04f;
								l2.GetComponent<Renderer> ().material.color = yellow;
								//lLight.transform.position = new Vector3(lLight.transform.position.x, l2.transform.position.y,lLight.transform.position.z);
								lLight.transform.position = l2.transform.position;
								lLight.GetComponent<Light> ().color = yellow;
								l3.GetComponent<Renderer> ().material.color = green * .04f;
			
								f1.GetComponent<Renderer> ().material.color = red;
								//fLight.transform.position = new Vector3(fLight.transform.position.x, f1.transform.position.y,fLight.transform.position.z);
								fLight.transform.position = f1.transform.position;
								fLight.GetComponent<Light> ().color = red;
								f2.GetComponent<Renderer> ().material.color = yellow * .04f;
								f3.GetComponent<Renderer> ().material.color = green * .04f;
			
								r1.GetComponent<Renderer> ().material.color = red * .04f;
								r2.GetComponent<Renderer> ().material.color = yellow;
								//rLight.transform.position = new Vector3(rLight.transform.position.x, r2.transform.position.y,rLight.transform.position.z);
								rLight.transform.position = r2.transform.position;
								rLight.GetComponent<Light> ().color = yellow;
								r3.GetComponent<Renderer> ().material.color = green * .04f;
						} else {
								t = 0;
								l = true;
						}

						lCone.GetComponent<Renderer> ().material.SetColor ("_TintColor", lLight.GetComponent<Light> ().color * .5f);
						lCone.GetComponent<Renderer> ().material.SetTextureOffset ("_MainTex", new Vector2 (0, Time.time * .1f));

						fCone.GetComponent<Renderer> ().material.SetColor ("_TintColor", fLight.GetComponent<Light> ().color * .5f);
						fCone.GetComponent<Renderer> ().material.SetTextureOffset ("_MainTex", new Vector2 (0, Time.time * .1f));

						rCone.GetComponent<Renderer> ().material.SetColor ("_TintColor", rLight.GetComponent<Light> ().color * .5f);
						rCone.GetComponent<Renderer> ().material.SetTextureOffset ("_MainTex", new Vector2 (0, Time.time * .1f));

						if (l != o) {
								aSources [0].Play ();
						}

						o = l;

				}
		}
}
