﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class tutorialAvatarBehave: MonoBehaviour
{
	
		public GameObject player;
		public bool highlight;

		public GameObject tutorialWindow, titleText;


		GameObject control;

		float i, t;

		bool old;

		WallBehave wall;

		void Start ()
		{
				for (int p =0; p < 12; p++) {
						if (p.ToString () == gameObject.name) {
								string name = "playerAvatars/" + p.ToString ();
								Texture2D thisTex = Resources.Load (name) as Texture2D;
								GetComponent<Renderer> ().material.SetTexture ("_MainTex", thisTex);

								name = "playerAvatarsNormals/" + p.ToString ();
								thisTex = Resources.Load (name) as Texture2D;
								GetComponent<Renderer> ().material.SetTexture ("_BumpMap", thisTex);

						}

				}
				i = 0;

				control = GameObject.Find ("controlHub");

				player = GameObject.Find ("player");

				wall = GameObject.FindGameObjectWithTag ("car").GetComponent<WallBehave> ();
		}
	
		void Update ()
		{
				t++;
				transform.LookAt (player.transform);

				if ((highlight) && (highlight != old)) {
						GetComponent<AudioSource> ().Play ();
				}

				if (highlight) {
						transform.localScale = new Vector3 (.9f, .9f, .09f);
						GetComponent<Renderer> ().material.SetFloat ("_AnimPowerY", .05f);
						GetComponent<Renderer> ().material.SetFloat ("_AnimPowerZ", .1f);
						GetComponent<Renderer> ().material.SetFloat ("_Saturated", 1.0f);


				} else {
						transform.localScale = new Vector3 (.6f, .6f, .06f);
						GetComponent<Renderer> ().material.SetFloat ("_AnimPowerY", 0);
						GetComponent<Renderer> ().material.SetFloat ("_AnimPowerZ", 0);
						GetComponent<Renderer> ().material.SetFloat ("_Saturated", 0);
				}


				if (t % 3 == 0) {
						i++;
				}

				old = highlight;
				highlight = false;
			
		}
	
		void spawnWindow ()
		{
				//control.GetComponent<controlHub> ().playerAva = GetComponent<Renderer> ().material.GetTexture ("_MainTex") as Texture2D;
				GameObject.Find ("statusBar").GetComponent<statusBehave> ().AssignAvater (GetComponent<Renderer> ().material.GetTexture ("_MainTex") as Texture2D);
				tutorialWindow.SetActive (true);
				titleText.SetActive (false);
				if (GameObject.Find ("avaPicker"))
						GameObject.Find ("avaPicker").SetActive (false);
				wall.GiveReward (6);
				Destroy (gameObject);
		}
}
