﻿using UnityEngine;
using System.Collections;

public class underWorldLoader : MonoBehaviour
{
		bool highlighted;
		public GameObject lightCone;
		Color coneColor;
		float alph = 0;
		public bool ready = true;
		public Color debugColor;
		public ParticleSystem windParts, secondParts;
		AudioSource[] aSources;

		int streetDone = 0;
		public TextMesh text;
		string readyText;

		public Timer timer;

		void Start ()
		{
				readyText = text.text;
				streetDone = PlayerPrefs.GetInt ("streetDone", 0);



				if (streetDone == 1) {
						text.text = "not again...";
						ready = false;
			
				} else {
						text.text = readyText;
						ready = true;
				}

				coneColor = lightCone.GetComponent<Renderer> ().material.GetColor ("_TintColor");
				aSources = GetComponents<AudioSource> ();

				timer = transform.Find ("Timer").GetComponent<Timer> ();

		}
	
		void Update ()
		{


				if (highlighted && ready) {
						if (timer.IsDone ()) {
								if (!aSources [1].isPlaying) {
										GameObject.Find ("fader").SendMessage ("loadLevel", 2f);
										aSources [1].Play ();
										timer.Stop ();
										timer.enabled = false;
								}
						}
						if (alph < 1) {
								alph += .05f;
						}
				} else {
						if (alph > 0) {
								alph -= .05f;
						}
				}

				if (alph < 0) {
						alph = 0;
				}

				if (alph > 1) {
						alph = 1;
				}
//				Debug.Log (alph);
				text.GetComponent<Renderer> ().material.color = new Color (200, 200, 0, alph);
				Color newCol = Color.Lerp (Color.black, coneColor, alph);
				debugColor = newCol;
				lightCone.GetComponent<Renderer> ().material.SetColor ("_TintColor", newCol);
				lightCone.GetComponent<Renderer> ().material.SetTextureOffset ("_MainTex", new Vector2 (0, Time.time / 5));
				aSources [0].volume = alph;
				windParts.emissionRate = 200 * alph;
				secondParts.emissionRate = 10 * alph;

				highlighted = false;
		}

		void activate ()
		{
			
		}

		void highlight ()
		{
				highlighted = true;
		}
}
