﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class bgBehave : MonoBehaviour
{

		public float scrollSpeed = 0.5F;
		public List<Texture2D> texList;
		public bool switchable = true;
		public float t, rand;
		public bool horizontal;

		void Start ()
		{
				texList = new List<Texture2D> ();
				int i = 0;
				bool looking = true;
		
				while (looking) {
						string name = "bgTextures/bg" + i.ToString ();
			
						Texture2D thisTex = Resources.Load (name) as Texture2D;
			
						if (thisTex != null) {
								texList.Add (thisTex);
								i++;
						} else {
								looking = false;
						}
				}
				if (switchable) {
						newTex ();
				}
		}
	
		// Update is called once per frame
		void Update ()
		{
				if (horizontal) {
						GetComponent<Renderer>().material.SetTextureOffset ("_MainTex", new Vector2 (0, Time.time * scrollSpeed));
				} else {
						GetComponent<Renderer>().material.SetTextureOffset ("_MainTex", new Vector2 (Time.time * scrollSpeed, 0));

				}

				t += Time.deltaTime;

				if (t > rand) {
						if (switchable) {
								newTex ();
						}
				}
		}

		void newTex ()
		{
				t = 0;
				GetComponent<Renderer>().material.SetTexture ("_MainTex", texList [Random.Range (0, texList.Count)]);

				rand = Random.Range (3f, 10f);
		}
}