﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class chatScreen : MonoBehaviour
{

		public GameObject screen;
		public GameObject inputBar;
		public GameObject typingText;
		public GameObject avatar;
		public GameObject bg;
		public GameObject rewardParticles;
		WallBehave wall;
		TextMesh userName = null;
		public string nameString;
		controlHub control;
		public int avatarIdentity; //which avatar is it?
		
		string wantedMes; //what does it want you to say

		int lifeSpan; //how old is it going to get b4 it dies
		public float life, t, debugLife; //how old is it/ (t is for floating mode)
	
		public bool activated; //is it active/will the keyboard inputs register
		bool dying; //is it on its way out/its too late!
		bool readyToSend; //when the number of legal key presses is equal to wantedMes.length
		
		public bool waiting, thinking, floating;
		float sinOffset, m;
		public Texture2D[] convoTex; // I HAVE THIS FUCKER UNDER MANUAL DRAG AND DROP CONTROL. IT DOES NOT GET DEFINED IN THIS SCRIPT SO STOP WASTING TIME LOOKING FOR IT.
		public Texture avatarTex;
		Color orig; // debug Activation Color

		public AudioClip alertSound;
		public AudioClip alarmSound;

		public int convoIndx;
		public string[] scriptLines;

		public bool highlight;

		public float distance;

		private statusBehave myStatus;
		private bool waitingForResponse = false;

		Transform AnchorPos;
		Vector3 ogCScale;
		//**********************************************************************************************************************************************

		
		//avatarIdentity = avatarImg;
		//transform.rotation = loc.rotation;
		//transform.localScale = loc.localScale;
		//convoTex = convoTexs; STILL HAVE THIS UNDER TIGHT DRAGDROP CONTROL

		void Start ()
		{
				Application.targetFrameRate = 60;

				debugLife = 0;

				control = GameObject.Find ("controlHub").GetComponent<controlHub> ();	
				name = "window" + control.GetComponent<controlHub> ().windowTracker.ToString ();
				control.windowTracker ++;


				userName = transform.Find ("userName").GetComponent<TextMesh> ();
				inputBar = GameObject.Find (name + "/inputBar");
				typingText = GameObject.Find (name + "/typingText");
				screen = GameObject.Find (name + "/screen");
				bg = GameObject.Find (name + "/bg");
				avatar = GameObject.Find (name + "/avatar");// assign the child components for easy access
				inputBar.GetComponent<inputBarControl> ().textGeo = typingText;
				wall = transform.Find ("Wall").GetComponent<WallBehave> ();
//				orig = screen.GetComponent<Renderer> ().material.color; // store the debug color
				avatar.GetComponent<Renderer> ().material.SetTexture ("_MainTex", avatarTex);

				waiting = true;//
				thinking = false;//
				floating = false;// start the default states

				convoIndx = 0; // each conversation starts at convoIndx 0
			
				myStatus = GameObject.Find ("statusBar").GetComponent<statusBehave> ();

				activate ();
				userName.text = nameString;

				transform.localScale = new Vector3 (1.05f, 1.05f, 2.5f);
				AnchorPos = transform.Find ("Anchor").transform;

				myStatus.AddConnection (AnchorPos);
				ogCScale = screen.GetComponent<BoxCollider> ().size;
		}
	
		void Update ()
		{
				bool sinking = false;

				debugLife += Time.deltaTime;

				if (control.endGame) {
						Destroy (this.gameObject);
				}
		
				if (activated) {
						screen.GetComponent<Renderer> ().material.SetColor ("_Color", Color.green);
						inputBar.SetActive (true);

						wall.gameObject.transform.localPosition = new Vector3 (wall.transform.localPosition.x, -1.75f, 3.25f);

						GameObject[] avatars = GameObject.FindGameObjectsWithTag ("avatar");

						foreach (GameObject a in avatars) {
								a.GetComponent<avatarBehave> ().typingBlock = true;
						}

						control.typingBlock = true;

						typingText.SetActive (true);
						if (convoIndx < scriptLines.Length) {
								if (convoIndx == 0) {
										inputBar.GetComponent<inputBarControl> ().typingLine = scriptLines [convoIndx];
								} else {
										inputBar.GetComponent<inputBarControl> ().typingLine = scriptLines [convoIndx];
								}
						}


				} else {
						screen.GetComponent<Renderer> ().material.SetColor ("_Color", orig);
						inputBar.SetActive (false);
						typingText.SetActive (false);
						wall.gameObject.transform.localPosition = new Vector3 (wall.transform.localPosition.x, -1.285f, 3.25f);



						if (waiting) {

								life += Time.deltaTime;
						}

		
						if (thinking) {

								if (Random.value <= .002f) {// THE PERSON RESPONDS!!!!!
										avatar.GetComponent<AudioSource> ().loop = false;
										avatar.GetComponent<AudioSource> ().Play ();
										myStatus.AddNotification (AnchorPos);
										wall.StartPulse (.1f);
										waitingForResponse = true;
										newMessage ();
										if (control.life < .5f && control.life > -.1) {
												control.life = 1;
										}
										control.statusCounter ++;
										rewardParticles.GetComponent<ParticleSystem> ().Emit (100); //make sure particle system is manually linked
										thinking = false;
										waiting = true;
								}
						}

						if (floating) {

								activated = false;
								t += Time.deltaTime;
								waiting = false;
								thinking = false;

								if (t > 20) {
										m -= .03f;
										myStatus.RemoveConnection (AnchorPos);
										sinking = true;

								}

								if (t > 30) {
										control.resetAvatar (avatarIdentity);
										Destroy (this.gameObject);
								}

						}

						if (highlight || activated) {
								transform.localScale = new Vector3 (1.05f, 1.05f, 2.5f);
								screen.GetComponent<BoxCollider> ().size = Vector3.Scale (ogCScale, new Vector3 (1.05f, 1.05f, 2.5f));
								highlight = false;
								bg.SetActive (true);
								avatar.GetComponent<Renderer> ().enabled = true;
								//wall.SetVisible (true);
						} else {
								transform.localScale = new Vector3 (1f, 1f, 2.5f);
								bg.SetActive (false);
								//avatar.GetComponent<Renderer> ().enabled = false;
								//userName.text = "";
								//wall.SetVisible (false);
								screen.GetComponent<BoxCollider> ().size = ogCScale;
						}
				}


				if (debugLife > 50) {
						if (convoIndx == 0) {
								waiting = false;
								thinking = false;
								floating = true;

								//	Debug.Log ("killed a window");
						}
				}
				if (sinking) {
						transform.Translate (0, -.02f, .015f);
				} else {
						float pLife = control.life;
						transform.position = new Vector3 (0, pLife + m, 0);
				}
		}// end  update

		void activate ()
		{
				bool alreadyOneActivated = false;
				if (waiting) {
						if (!activated) {
								for (int x = 0; x < 14; x++) {
										GameObject win = GameObject.Find ("window" + x.ToString ());

										if (x > 9) {
												win = GameObject.Find ("window" + x.ToString ());
										}
										if (win != null) {
												
												if (win.GetComponent<chatScreen> ().activated == true) {
														alreadyOneActivated = true;
												}
										}
								} 															// make sure only one window is active at a time.
						}
		
						if (!inputBar.GetComponent<inputBarControl> ().readyToSend) {
								if (!alreadyOneActivated) {
										activated = true;
										myStatus.RemoveNotification (AnchorPos);

										if (waitingForResponse) {
												waitingForResponse = false;
										}
								}
						}
				}
		}

		void rightAnswer ()
		{
				life -= 10;
				newMessage ();
				screen.GetComponent<AudioSource> ().clip = alertSound;
				control.sinkSpeed += control.GetComponent<controlHub> ().sinkSpeed / 15f;
				control.statusCounter ++;
				rewardParticles.GetComponent<ParticleSystem> ().Emit (100);
				if (convoIndx > 1) {
						wall.StopPulse ();
				}
				if (control.life < .5f) {
						control.life = .5f;
				}

				GameObject[] avatars = GameObject.FindGameObjectsWithTag ("avatar");
		
				foreach (GameObject a in avatars) {
						a.GetComponent<avatarBehave> ().typingBlock = false;
				}
				control.typingBlock = false;

				avatar.GetComponent<AudioSource> ().loop = false;
				screen.GetComponent<AudioSource> ().loop = false;
				screen.GetComponent<AudioSource> ().Play ();
				waiting = false;
				thinking = true;
				activated = false;

				if (convoIndx == convoTex.Length - 1) {
						floating = true;
						thinking = false;
				}
		}

		void newMessage ()
		{
				control.sinkSpeed += control.GetComponent<controlHub> ().sinkSpeed / 20f;
				control.adSpawnRate -= 1f;

				if (convoIndx < convoTex.Length - 1) {
						convoIndx++;
				}

				if (convoIndx >= convoTex.Length) {
						floating = true;

						waiting = false;
						thinking = false;
				}
				screen.GetComponent<Renderer> ().material.SetTexture ("_MainTex", convoTex [convoIndx]);

				//thinking = false;
				//waiting = true;
		}

		void parseScript (string script)
		{
				scriptLines = script.Split ('/');
		}

		void parseImages (List<Texture2D> inImages)
		{
				//convoTex = inImages;
				convoTex = new Texture2D[inImages.Count];

				for (int x = 0; x < inImages.Count; x++) {
						convoTex [x] = inImages [x];
				}

				screen = GameObject.Find (name + "/screen");
				screen.GetComponent<Renderer> ().material.SetTexture ("_MainTex", convoTex [0]);

		}


}

