﻿using UnityEngine;
using System.Collections;

public class echoPointLoader : MonoBehaviour
{
		public bool highlighted, old;
		Vector3 ogScale;
		MovieTexture echoMovie;
		public bool ready = true;
		AudioSource[] aSources;
		float alph = 0;
		public TextMesh text;
		int echoDone;
		GameObject screen;
		GameObject screenOut;

		ParticleSystem rewardParticles;

		public Timer timer;
	
		void Start ()
		{
				echoDone = PlayerPrefs.GetInt ("echoDone", 0);
				if (echoDone == 1) {
						text.text = "not again...";
						ready = false;
			
				} else {
						text.text = "use echoPoint";
						ready = true;
				}
				screen = transform.Find ("screen").gameObject;
				screenOut = transform.Find ("screenOut").gameObject;
				ogScale = transform.localScale;
				echoMovie = Resources.Load ("echoLoader") as MovieTexture;
				screenOut.GetComponent<Renderer> ().material.mainTexture = echoMovie;
				rewardParticles = transform.Find ("rewardParticles").GetComponent<ParticleSystem> ();
				screen.GetComponent<Renderer> ().material.mainTexture = echoMovie;
				echoMovie.Play ();
				timer = transform.Find ("Timer").GetComponent<Timer> ();

				aSources = GetComponents<AudioSource> ();
		}

		void Update ()
		{

				if ((highlighted) && (highlighted != old)) {
				}
				if (highlighted && ready) {
						if (timer.IsDone ()) {
								if (!aSources [0].isPlaying) {
										GameObject.Find ("fader").SendMessage ("loadLevel", 1f);
										aSources [0].Play ();
										timer.Stop ();
										timer.enabled = false;

								}
						}
						if (!echoMovie.isPlaying) {
								echoMovie.Play ();
						}
						if (alph < 1) {
								alph += .05f;

						}
				} else {
						if (echoMovie.isPlaying) {
								//	echoMovie.Pause ();
						}
						if (alph > 0) {
								alph -= .1f;
						}

				}
				rewardParticles.emissionRate = map (alph, 0, 1, 0, 15);
				text.GetComponent<Renderer> ().material.color = new Color (200, 200, 0, alph);
				old = highlighted;
				aSources [1].volume = alph;
				highlighted = false;
		}

		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}

		void highlight ()
		{
				highlighted = true;
		}
}
