﻿using UnityEngine;
using System.Collections;

public class faderBehave : MonoBehaviour
{
		public bool fadeLevelIn, fadeLevelOut;
		float alph;
		int levelToLoad;

		public bool fading = false;
		public GameObject softParent;

		void Start ()
		{
				GetComponent<MeshRenderer> ().enabled = true;
				fadeLevelIn = true;
				fadeLevelOut = false;
				alph = 1;
				AudioListener.volume = -.5f;
		}
	
		void Update ()
		{
				transform.position = new Vector3 (softParent.transform.position.x, transform.position.y, softParent.transform.position.z);

				if (fadeLevelOut) {
						fadeLevelIn = false;
				}

				if (fadeLevelIn) {

						alph -= .005f;

				}

				if (fadeLevelOut) {
						alph += .005f;
						fading = true;
				}

				if ((fadeLevelIn) || (fadeLevelOut)) {
						GetComponent<Renderer> ().material.color = new Color (0, 0, 0, alph);
						AudioListener.volume = 1 - alph;
				}

				if (alph <= 0) {
						fadeLevelIn = false;
				}

				if ((alph >= 1) && (fadeLevelOut)) {
						fadeLevelOut = false;

						Application.LoadLevel (levelToLoad);
				}

		}

		public void loadLevel (float levelIndex)
		{
				levelToLoad = (int)levelIndex;
				fadeLevelOut = true;
				fading = true;
		}
}
