﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;



public class locationControl : MonoBehaviour {

	public GameObject popUpTemplate,control;
	GameObject texList;

	float t;

	public List<List<Texture2D>> texMegaList;

	public GameObject sceneBG;

	public List <Texture2D> locationBGs;

	int i;

	void Start () {
		i =0;
		t =0;
		control = GameObject.Find("controlHub");

		texMegaList = new List<List<Texture2D>>(); // the creation of the master list of lists.
		
		bool lookingForConversations = true; // still looking for more conversation groups. It is turned to false when "k_0" returns null.
		int k=0;//this is the first number, the number of the conversation. This increments until "k_0" returns null.
		List<Texture2D> convoGroup; // The mini placeholder list that will be used to fill the megaList. This will happen every time "k_l" returns null.
		
		while(lookingForConversations){ //this will only go thru once, when it is false, all the images will be loaded.
			bool lookingForLines = true; // this is controlling when its looking for individual lines
			
			convoGroup = new List<Texture2D>(); // make the mini list, the one that will be added to the mega list.
			int l=0; // we are starting by looking for k_0.
			while(lookingForLines){ //this is the process of looking for each image.
				//this is the second number, the number of the line within the conversation. it increments until "k_l" returns null.
				string name = "locations/loc"+ k.ToString() + "_" + l.ToString(); // the images are named "0_1, 4_3 and so on.
				Texture2D thisTex = Resources.Load<Texture2D>(name); // get the next texture, will return "null" if it doesnt exist.
				
				if(l == 0){ //check if we are done with all of them, meaning, k_0 returns false.
					if(thisTex == null){ // does it?
						lookingForConversations = false;// ok we are done, they are all loaded.
						break;
					}
				}
				if(thisTex !=null){ //otherwise, add it to the mini group
					convoGroup.Add (thisTex);
					l++; // look for the next line
				}else{
					texMegaList.Add(convoGroup); // oh it isnt there? ok we are done with this group, add the group we have to the mega group and flush it out.
					lookingForLines = false; // we are out of the mini line loop
					k++; //  start the whole thing again with a new k
				}
			}
			
		}
	}
	
	void Update () {

		if(control.GetComponent<controlHub>().endGame){
			Destroy(this.gameObject);
		}

		t += Time.deltaTime;

		if(Input.GetKeyDown(KeyCode.PageUp)){
			newPopUp();
		}

		if(t > 45){
			t =0;
			newPopUp();
		}
	}

	void newPopUp(){

		GameObject newPopUp = Instantiate(popUpTemplate, transform.position, Quaternion.identity) as GameObject;
		List <Texture2D> texx = texMegaList[i];
		newPopUp.SendMessage("parseImages", texx);

	}

	void changeBG(){
		sceneBG.GetComponent<Renderer>().material.SetTexture("_MainTex", locationBGs[i]);
		i++;
	}


}
