﻿using UnityEngine;
using System.Collections;

public class meshDeform: MonoBehaviour
{
	public float globalScale = 10f;
	private Vector3[] originalVerticesStorage;


	void Start ()
	{
		Mesh mesh = GetComponent<MeshFilter> ().mesh;
		Vector3[] vertices = mesh.vertices;
		
		originalVerticesStorage = vertices;
	}
	
	void Update (){
		
		Mesh mesh = GetComponent<MeshFilter> ().mesh;
		Vector3[] vertices = mesh.vertices;
		int k = 0;
		float step =.001f;
		while (k < vertices.Length) {
			vertices [k] = Vector3.MoveTowards (vertices[k], originalVerticesStorage[k], step);
			k++;
		}
		mesh.vertices = vertices;

	}
	
	void reset() {
		Mesh mesh = GetComponent<MeshFilter> ().mesh;
		Vector3[] vertices = mesh.vertices;
		vertices = originalVerticesStorage;
		mesh.vertices = vertices;
		
	}
	
	void OnApplicationQuit() {
		Mesh mesh = GetComponent<MeshFilter> ().mesh;
		Vector3[] vertices = mesh.vertices;
		vertices = originalVerticesStorage;
		mesh.vertices = vertices;
		
	}
	
	void randomVerts (float localScale, int multiple){
		Mesh mesh = GetComponent<MeshFilter> ().mesh;
		Vector3[] vertices = mesh.vertices;
		//				Vector3[] normals = mesh.normals;
		int i = 0;
		while (i < vertices.Length) {
			if (i % multiple == 0){
				vertices [i] += new Vector3 (Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale, Random.Range (-1f, 1f) * globalScale * localScale);
			}		
			i++;
		}
		mesh.vertices = vertices;
	}


	void distort(){
		randomVerts(.00025f,1);

		globalScale+=globalScale/1000f;
	}

	void distortLite(){
		randomVerts(.001f,1);
		globalScale+=globalScale/3000f;
	}
}
