﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class peopleControl : MonoBehaviour {

	int[] pI; 

	public List<GameObject> people;

	void Awake () {

		foreach (Transform child in transform)
		{
			people.Add (child.gameObject);
		}

		pI = new int [48];
		for (int x =0; x < 48; x ++) {
			pI[x] = (x);
				}

		for (int i = 0; i < pI.Length; i++) {
			int temp = pI[i];
			int randomIndex = Random.Range(i, pI.Length);
			pI[i] = pI[randomIndex];
			pI[randomIndex] = temp;
		}

		for (int x = 0; x < people.Count; x ++) {
			int suffix = pI[x];

			people[x].gameObject.name = "person" + suffix.ToString();
				}

	}
	
	void Update () {
	
	}


}
