﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
public class streetPerson : MonoBehaviour
{
	
		GameObject player;
		public bool activated, playing;
	
		string baseName;
		public List<Texture2D> texList;
		int i = 1;
		int speed = 1;
		public int frameRate = 2;
	
		float life = 0;
		bool dead = false;
	
//		float globalScale = 10f;
//		Vector3[] originalVerticesStorage;
	
		public AudioClip[] convoAudio;
	
		public AudioClip breakSound;
	
		//public bool streetPerson;
	
//		Vector3 ogPos;
//		Vector2 seed = new Vector2 (0, 0);
		float walkSpeed = -.1f;
	
		void Start ()
		{
				i = 0;
				bool looking = true;
		
				baseName = this.name;
		
				while (looking) {
						string name;
						if (i < 10) {
								name = baseName + "/" + baseName + "_0" + i.ToString ();
						} else {
								name = baseName + "/" + baseName + "_" + i.ToString ();
						}
			
						Texture2D thisTex = Resources.Load (name) as Texture2D;
			
						if (thisTex != null) {
								texList.Add (thisTex);
								i++;
						} else {
								looking = false;
						}
				}
		
				i = 1;
		
				player = GameObject.Find ("player");
				GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [0]);
				//meshDeformStuff
//				Mesh mesh = GetComponent<MeshFilter> ().mesh;
//				Vector3[] vertices = mesh.vertices;
		
				//		originalVerticesStorage = vertices;
		
				//	GetComponent<AudioSource> ().clip = convoAudio [Random.Range (0, convoAudio.Length)];
				//GetComponent<AudioSource> ().Play ();
		
//				ogPos = transform.position;
//				seed = new Vector2 (Random.Range (0, 1000), Random.Range (0, 1000));

				walkSpeed = Random.Range (.05f, .1f);
		}
	
		void Update ()
		{
				Vector3 point = new Vector3 (player.transform.position.x, transform.position.y, player.transform.position.z);
				transform.LookAt (point, Vector3.up);
		
				//increment life
				if ((activated) && (!dead)) {
						life += Time.deltaTime;
				}
				//switch textures if playing
				if (playing) {
						if (Time.frameCount % frameRate == 0) {
								if (i == 1) {
										speed = 1;
								}
				
								if (i == texList.Count - 1) {
										speed = -1;
								}
				
								if ((i < 15) && (speed == -1) && (activated)) {
										speed = 1;
								}
				
								if ((i < 2) && (!activated)) {
										playing = false;			
								}
				
								i += speed; 
								GetComponent<Renderer> ().material.SetTexture ("_MainTex", texList [i - 1]);
						}
				}
				//raise player if close enough
				float distToPlayer = Vector3.Distance (player.transform.position, transform.position);


				transform.Translate (0, 0, walkSpeed * -1f, Space.World);
				activated = false;
				if (distToPlayer < 20) {
//						float partMap = map (distToPlayer, 0, 20, 0, .5f);
						GetComponent<Renderer> ().material.SetFloat ("_C", Random.value);
						GetComponent<Renderer> ().material.SetFloat ("_B", Random.value);
				}
		}
		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}

		void activate ()
		{
				activated = true;
				playing = true;
		}
}
