﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;


public class texturePlayer : MonoBehaviour {

	public string baseName;

	public List<Texture2D> texList;

	public int i =1;

	int t,tt;

	public int speed;

	public bool underscore,reverseLoop;

	public bool automatic;

	bool chosen;

	public float frameRate =3;



	void Start () { 
		speed = 1;
		chosen = false;

		if(automatic == false){
			bool looking = true;
			
			while(looking){
				string name;
				if(underscore){
					name = baseName + "/" + baseName+ "_" + i.ToString();
				}else{
					name = baseName + "/" + baseName + i.ToString();
					
				}
				
				Texture2D thisTex = Resources.Load(name) as Texture2D;
				
				if(thisTex != null){
					texList.Add(thisTex);
					i++;
				}else{
					looking = false;
				}
			}
			
			i =1;
			t =0;
		}
	}
	
	void Update () {
		if(tt % frameRate == 0){

		if((chosen)||(automatic == false)){
		t++;

		if(t % 3 == 0){
		if(reverseLoop){
			if(i == 1){
				speed =1;
			}
			if(i == texList.Count-1){
				speed = -1;
			}
			   }

		if(!reverseLoop){
			//speed = 1;
			if(i ==texList.Count){
				i=1;
			}
		}

		i+=speed;

		GetComponent<Renderer>().material.SetTexture("_MainTex", texList[i-1]);

		}
		}
		}
		tt++;
	}

	void parseImages(string inName){
		baseName = inName;
		bool looking = true;
		
		while(looking){
			string name;
			if(underscore){
				name = baseName + "/" + baseName+ "_" + i.ToString();
			}else{
				name = baseName + "/" + baseName + i.ToString();
				
			}
			
			Texture2D thisTex = Resources.Load(name) as Texture2D;
			
			if(thisTex != null){
				texList.Add(thisTex);
				i++;
			}else{
				looking = false;
			}
		}
		
		i =1;
		t =0;

		chosen = true;
	}
}
