﻿using UnityEngine;
using System.Collections;

public class walker : MonoBehaviour
{

		public Camera cam;
		public float speed, saveSpeed;
		GameObject mover;
		public bool freeWalk = false;
		float minHeight, maxHeight, height;

		public ParticleSystem parts;

		public float life = 2f;
		public bool sinking, raisingUp, moving;

		float sinkSpeed = 0;

		bool slowed = false;

		void Start ()
		{

				transform.position = GameObject.Find ("playerStart").transform.position;
				speed = 7f;
				mover = GameObject.Find ("mover");
				life = 1;
				sinking = false;
				moving = false;
				saveSpeed = speed;
		}
	
		void Update ()
		{
				mover.transform.eulerAngles = new Vector3 (mover.transform.eulerAngles.x, transform.eulerAngles.y, mover.transform.eulerAngles.z);
				if (life > .15f) {
						if (Input.GetAxis ("Vertical") > 0) {
								sinking = true;
								moving = true;
								if (!raisingUp) {
										transform.Translate (mover.transform.forward * Time.deltaTime * speed * Input.GetAxis ("Vertical"), Space.World);
								}
						}
						if (Input.GetAxis ("Vertical") < 0) {
								sinking = true;
								moving = true;
								if (!raisingUp) {
										transform.Translate (mover.transform.forward * Time.deltaTime * speed * -1 * Input.GetAxis ("Vertical"), Space.World);
								}
						}
				} else {
					
						GameObject.Find ("fader").SendMessage ("loadLevel", 0f);
						sinking = false;
						PlayerPrefs.SetInt ("streetDone", 1);
				}

				transform.Rotate (0, Input.GetAxis ("Horizontal"), 0);
				
				

				if (raisingUp) {
						parts.emissionRate = 50;
						raisingUp = false;
						if (life < 1) {
								life += .006f;
						}
				} else {
						parts.emissionRate = 0;
				}

				//sinking mechanic
				if (sinking) {
						if (freeWalk) {
								life -= sinkSpeed;
						} else {
								if (!moving) {
										life -= .002f;
								} else {
										if (life < 1) {
												life += .004f;
										}
								}
						}
				}

				moving = false;

				height = map (life, 0, 1, -5.428f, 9.378f);
				transform.position = new Vector3 (transform.position.x, height, transform.position.z);

		} 

		float map (float s, float a1, float a2, float b1, float b2)
		{
				return b1 + (s - a1) * (b2 - b1) / (a2 - a1);
		}

		public void AddSink ()
		{
				sinkSpeed += .0003f;
				speed += .3f;
		}
		public void SetSlowdown (bool status)
		{
				//	if (status) {
				//			if (!slowed) {
				//					saveSpeed = speed;
				//					speed = 5;
				//					slowed = true;
				//			}
				//	} else {
				//			speed = saveSpeed;
				//			slowed = false;
				//	}
		}
}
